<?php
/**
 * MIT License
 *
 * Copyright (c) 2017 CM Groep
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * @category   CMGroep
 * @package    Idin
 * @author     Epartment Ecommerce B.V. <support@epartment.nl>
 * @copyright  2016-2017 CM Groep
 * @license    http://www.opensource.org/licenses/mit-license.html  MIT License
 */

class CMGroep_Idin_Block_Checkout_Onepage extends Mage_Checkout_Block_Onepage
{
    /**
     * Add the age verification step to the default OnePageCheckout steps
     * when age verification is active
     *
     * @return array Steps for checkout
     */
    public function getSteps()
    {
        if (Mage::helper('cmgroep_idin')->getIdinAgeVerificationActive()
            && Mage::helper('cmgroep_idin')->ageVerificationRequired(true) && Mage::helper('cmgroep_idin')->getExtensionActive()) {
            $steps = parent::getSteps();

            $ageVerificationStep = array(
                'age_verification' => array(
                    'label' => Mage::helper('cmgroep_idin')->__('Age Verification'),
                    'allow' => true
                )
            );

            if (array_key_exists('login', $steps)) {
                $steps = array_merge(
                    array_slice($steps, 0, 1, true), $ageVerificationStep,
                    array_slice($steps, 1, null, true)
                );
            } else {
                $steps = array_merge($ageVerificationStep, $steps);
            }

            return $steps;
        }

        return parent::getSteps();
    }
}